<html>
<head>
<title>OgreShaderGLSLESProgramWriter.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderGLSLESProgramWriter.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderGLSLESProgramWriter_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderProgramWriterGLSLES_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderProgramWriterGLSLES_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderProgramWriterManager_8h.html">OgreShaderProgramWriterManager.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>Ogre {
<a name="l00033"></a>00033 <span class="keyword">namespace </span>RTShader {
<a name="l00034"></a>00034 
<a name="l00045"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html">00045</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html" title="GLSL ES target language writer implementation.">GLSLESProgramWriter</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047     <span class="comment">// Interface.</span>
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00053"></a>00053     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a6476d951d9c0ee8bb85d0b490e74300e" title="Class constructor.">GLSLESProgramWriter</a> ();
<a name="l00054"></a>00054 
<a name="l00056"></a>00056     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12c7055a4aa2015c33d1efcba52a74da" title="Class destructor.">~GLSLESProgramWriter</a>    ();
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00062"></a>00062 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a87e5c1203bdc1fafb5ca3be4636e5e32">writeSourceCode</a>         (<a class="code" href="classOgre_1_1StringSerialiser.html" title="Serializes data values into a string using sprintf functions.">StringSerialiser</a>&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* program);
<a name="l00064"></a>00064 <span class="preprocessor">#else</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a87e5c1203bdc1fafb5ca3be4636e5e32">writeSourceCode</a>         (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* program);
<a name="l00066"></a>00066 <span class="preprocessor">#endif</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00071"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a314654f81c05e2b12e1e4d627e2787f5">00071</a>     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a314654f81c05e2b12e1e4d627e2787f5">getTargetLanguage</a>       ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a837e41776125868b35313319357568b4">TargetLanguage</a>; }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a837e41776125868b35313319357568b4">00073</a>     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a837e41776125868b35313319357568b4">TargetLanguage</a>;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     <span class="keyword">protected</span>:
<a name="l00076"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">00076</a>     <span class="keyword">typedef</span>     std::map&lt;GpuConstantType, const char*&gt;      <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">GpuConstTypeToStringMap</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">00077</a>     <span class="keyword">typedef</span>     std::map&lt;Parameter::Semantic, const char*&gt;  <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">ParamSemanticToStringMap</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">00078</a>     <span class="keyword">typedef</span>     std::map&lt;Parameter::Content, const char*&gt;   <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">ParamContentToStringMap</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">00079</a>     <span class="keyword">typedef</span>     std::map&lt;String, String&gt;                    <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>;
<a name="l00080"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">00080</a>     <span class="keyword">typedef</span>     std::map&lt;FunctionInvocation, String&gt;        <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">FunctionMap</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">00081</a>     <span class="keyword">typedef</span>     std::vector&lt;FunctionInvocation&gt;             <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">FunctionVector</a>;
<a name="l00082"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a4bbd352818d0e9a370658c3dd46b53d6">00082</a>     <span class="keyword">typedef</span>     FunctionMap::const_iterator                 <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a4bbd352818d0e9a370658c3dd46b53d6">FunctionMapIterator</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a679ccd9ab1ce495e759675534c3b6568">00083</a>     <span class="keyword">typedef</span>     FunctionVector::const_iterator              <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a679ccd9ab1ce495e759675534c3b6568">FunctionVectorIterator</a>;
<a name="l00084"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a800ca3e3f67302866f7901491b4e8a94">00084</a>     <span class="keyword">typedef</span>     GpuConstTypeToStringMap::const_iterator     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a800ca3e3f67302866f7901491b4e8a94">GpuConstTypeToStringMapIterator</a>;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086     <span class="comment">// Protected methods.</span>
<a name="l00087"></a>00087 <span class="keyword">protected</span>:
<a name="l00088"></a>00088 
<a name="l00090"></a>00090     <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a7bcd6a3f3d32a4c0f618b843806c3409" title="Initialize string maps.">initializeStringMaps</a>        ();
<a name="l00091"></a>00091 
<a name="l00093"></a>00093     <span class="keyword">virtual</span> <span class="keywordtype">void</span>        <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a746a27ed72bbf45e930dbc34d180d09e" title="Cache functions of a dependency.">cacheDependencyFunctions</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; libName);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00097"></a>00097     <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a>  *<a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a7681f909aa467939c4c34db9c8b436d1" title="Create a FunctionInvocation object from a string taken out of a shader library.">createInvocationFromString</a> (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; input);
<a name="l00098"></a>00098 
<a name="l00100"></a>00100 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a80f56e3ca546c366b0d9cb5303043239" title="Write the program dependencies.">writeProgramDependencies</a>    (<a class="code" href="classOgre_1_1StringSerialiser.html" title="Serializes data values into a string using sprintf functions.">StringSerialiser</a>&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* program);
<a name="l00102"></a>00102 <span class="preprocessor">#else</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a80f56e3ca546c366b0d9cb5303043239" title="Write the program dependencies.">writeProgramDependencies</a>    (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Program.html" title="A class that represents a shader based program.">Program</a>* program);
<a name="l00104"></a>00104 <span class="preprocessor">#endif</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span>
<a name="l00107"></a>00107 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#abef9adf83addddd76b1836cc971eee1a" title="Write a local parameter.">writeLocalParameter</a>         (<a class="code" href="classOgre_1_1StringSerialiser.html" title="Serializes data values into a string using sprintf functions.">StringSerialiser</a>&amp; os, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00109"></a>00109 <span class="preprocessor">#else</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#abef9adf83addddd76b1836cc971eee1a" title="Write a local parameter.">writeLocalParameter</a>         (std::ostream&amp; os, <a class="code" href="classOgre_1_1SharedPtr.html">ParameterPtr</a> parameter);
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00114"></a>00114 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12e1a4545a050fcae65e3eba7e3252c0" title="Write the input params of the function.">writeInputParameters</a>        (<a class="code" href="classOgre_1_1StringSerialiser.html" title="Serializes data values into a string using sprintf functions.">StringSerialiser</a>&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* <span class="keyword">function</span>, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00116"></a>00116 <span class="preprocessor">#else</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12e1a4545a050fcae65e3eba7e3252c0" title="Write the input params of the function.">writeInputParameters</a>        (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* <span class="keyword">function</span>, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00118"></a>00118 <span class="preprocessor">#endif</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span>    
<a name="l00121"></a>00121 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a9362f13819d3e0ea24e8764fe611cb1f" title="Write the output params of the function.">writeOutParameters</a>          (<a class="code" href="classOgre_1_1StringSerialiser.html" title="Serializes data values into a string using sprintf functions.">StringSerialiser</a>&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* <span class="keyword">function</span>, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00123"></a>00123 <span class="preprocessor">#else</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>    <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a9362f13819d3e0ea24e8764fe611cb1f" title="Write the output params of the function.">writeOutParameters</a>          (std::ostream&amp; os, <a class="code" href="classOgre_1_1RTShader_1_1Function.html" title="A class that represents a shader based program function.">Function</a>* <span class="keyword">function</span>, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00125"></a>00125 <span class="preprocessor">#endif</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>
<a name="l00127"></a>00127 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>    <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#aee0e2df004d5e7d2c5e312f180b336ee">writeAssignFunction</a>(<a class="code" href="classOgre_1_1StringSerialiser.html" title="Serializes data values into a string using sprintf functions.">StringSerialiser</a>&amp; os, FunctionInvocation::OperandVector::iterator itOperand, FunctionInvocation::OperandVector::iterator itOperandEnd, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00129"></a>00129 <span class="preprocessor">#else</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>    <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#aee0e2df004d5e7d2c5e312f180b336ee">writeAssignFunction</a>(<a class="code" href="namespaceOgre.html#a64e76a61ffe0fc66797727c518151d35">std::stringstream</a>&amp; os, FunctionInvocation::OperandVector::iterator itOperand, FunctionInvocation::OperandVector::iterator itOperandEnd, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00131"></a>00131 <span class="preprocessor">#endif</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>
<a name="l00133"></a>00133     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a879358138a4325ca23065cf454829e11">processOperand</a>(<a class="code" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a> op, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gpuType);
<a name="l00134"></a>00134     
<a name="l00136"></a>00136     <span class="keywordtype">bool</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a0fdbf3067b64c149dee82c7c11ecd161" title="Check if a string matches one of the GLSL ES basic types.">isBasicType</a>(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;type);
<a name="l00137"></a>00137     
<a name="l00139"></a>00139     <span class="keywordtype">void</span>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a1fb686334668dd6a3cf729e6446d5ac1" title="Search within a function body for non-builtin functions that a given function invocation depends on...">discoverFunctionDependencies</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> &amp;invoc, <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">FunctionVector</a> &amp;depVector);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="comment">// Attributes.</span>
<a name="l00142"></a>00142 <span class="keyword">protected</span>:
<a name="l00143"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5ada74c1fe3817cec67e8f6a10a186a7">00143</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">GpuConstTypeToStringMap</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5ada74c1fe3817cec67e8f6a10a186a7">mGpuConstTypeMap</a>;               <span class="comment">// Map between GPU constant type to string value.</span>
<a name="l00144"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a97bb9afd75a1d22ddbcb5f10e07387f7">00144</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">ParamSemanticToStringMap</a>    <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a97bb9afd75a1d22ddbcb5f10e07387f7">mParamSemanticMap</a>;              <span class="comment">// Map between parameter semantic to string value.</span>
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a072bb41a8bfb1269eabb78b8e4677026">00146</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>                   <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a072bb41a8bfb1269eabb78b8e4677026">mInputToGLStatesMap</a>;            <span class="comment">// Map parameter name to a new parameter name (sometimes renaming is required to match names between vertex and fragment shader)</span>
<a name="l00147"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ad4c61befd054220be587d8ef09238d8c">00147</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">FunctionMap</a>                 <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ad4c61befd054220be587d8ef09238d8c">mFunctionCacheMap</a>;              <span class="comment">// Map function invocation to body.  Used as a cache to reduce library file reads and for inlining</span>
<a name="l00148"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a864563e76ac05d24f3d96327f94ac8b7">00148</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>                   <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a864563e76ac05d24f3d96327f94ac8b7">mDefinesMap</a>;                    <span class="comment">// Map of #defines and the function library that contains them</span>
<a name="l00149"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a520dea173b0e00ae96c56b2354cead90">00149</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">ParamContentToStringMap</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a520dea173b0e00ae96c56b2354cead90">mContentToPerVertexAttributes</a>;  <span class="comment">// Map parameter content to vertex attributes</span>
<a name="l00150"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a34feadf754410c6f87d0b618507ab61d">00150</a>     <span class="keywordtype">int</span>                         <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a34feadf754410c6f87d0b618507ab61d">mGLSLVersion</a>;                   <span class="comment">// Holds the current glsl es version</span>
<a name="l00151"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ae6f17f7fe43510fdbddb1e17c844d0dc">00151</a>     <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>                <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ae6f17f7fe43510fdbddb1e17c844d0dc">mFragInputParams</a>;               <span class="comment">// Holds the fragment input params </span>
<a name="l00152"></a><a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a8eb977d474ffb205906396cced806bb7">00152</a>     <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>                   <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a8eb977d474ffb205906396cced806bb7">mCachedFunctionLibraries</a>;       <span class="comment">// Holds the cached function libraries</span>
<a name="l00153"></a>00153 };
<a name="l00154"></a>00154 
<a name="l00158"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html">00158</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html" title="GLSL ES program writer factory implementation.">ShaderProgramWriterGLSLESFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriterFactory.html" title="Interface definition for factories of ShaderProgramWriter.">ProgramWriterFactory</a>
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160 <span class="keyword">public</span>:
<a name="l00161"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a61d146607c836f6bcc06577c17327528">00161</a>     <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a61d146607c836f6bcc06577c17327528">ShaderProgramWriterGLSLESFactory</a>()
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163         <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a76325a0caf34ce3e6696dc311f5560cf">mLanguage</a> = <span class="stringliteral">&quot;glsles&quot;</span>;
<a name="l00164"></a>00164     }
<a name="l00165"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a72e93f5574eacb788272c4a6f523adf9">00165</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a72e93f5574eacb788272c4a6f523adf9">~ShaderProgramWriterGLSLESFactory</a>() {}
<a name="l00166"></a>00166 
<a name="l00170"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a0273a86a577864598beddd78122ada86">00170</a>     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a0273a86a577864598beddd78122ada86">getTargetLanguage</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword">    </span>{
<a name="l00172"></a>00172         <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a76325a0caf34ce3e6696dc311f5560cf">mLanguage</a>;
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174 
<a name="l00178"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#aea9319ad43b5d3ad310b95cf1feb92a7">00178</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>* <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#aea9319ad43b5d3ad310b95cf1feb92a7">create</a>(<span class="keywordtype">void</span>)
<a name="l00179"></a>00179     {
<a name="l00180"></a>00180         <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html" title="GLSL ES target language writer implementation.">GLSLESProgramWriter</a>();
<a name="l00181"></a>00181     }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">private</span>:
<a name="l00184"></a><a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a76325a0caf34ce3e6696dc311f5560cf">00184</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RTShader_1_1ShaderProgramWriterGLSLESFactory.html#a76325a0caf34ce3e6696dc311f5560cf">mLanguage</a>;
<a name="l00185"></a>00185 };
<a name="l00186"></a>00186 
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
